; SOFTICE detector and "remover" by trapflag

; this vxd will hopefully detect softice in memory and disable its
; hotkey handler - currently it patches it with two NOPs,
; so sice is still accessible in a way (through breakpoints and so on).
; You may patch it with EBFE as well..
; If you're gonna use the code in your programs, give me some credits
; and send me a copy of your program.
; greetings go to the_owl for some help.
; trapflag@backtrace.de

.486p
include vmm.inc
include vwin32.inc
include shell.inc

DECLARE_VIRTUAL_DEVICE DBG,1,0,DBG_Control,UNDEFINED_DEVICE_ID,UNDEFINED_INIT_ORDER

Begin_control_dispatch DBG
	Control_Dispatch Sys_Dynamic_Device_Init,OnDeviceInit		;messages that
	Control_Dispatch Sys_Dynamic_Device_Exit,OnDeviceDestroy	;must be handled
	Control_Dispatch w32_DeviceIoControl,OnDeviceIoControl
End_control_dispatch DBG

; --------------------------------------------------------------
; Locked Data Segment
; --------------------------------------------------------------

VxD_LOCKED_DATA_SEG

;some variables

sequence db 0e4h,060h		;opcodes for in al,60 softice's "hotkey handler" 
Message db 'SoftIce detected and disabled!',0
Caption db 0
pszName db 80 dup(0)
scasb_exception Exception_Handler_Struc <>

VxD_LOCKED_DATA_ENDS

; --------------------------------------------------------------
; Locked Code Segment
; --------------------------------------------------------------

VxD_PAGEABLE_CODE_SEG

BeginProc OnDeviceInit		;if device is being loaded by user
;		int 3

		mov	scasb_exception.EH_Reserved,0
		mov	scasb_exception.EH_Start_EIP,offset32 scasb_protect
		mov	scasb_exception.EH_End_EIP,offset32 scasb_endprotect
		mov	scasb_exception.EH_Handler,offset32 EHandler

		mov     esi, offset32 scasb_exception
		VMMCall Install_Exception_Handler	;set up exception handler to handle page faults

		cld
		mov	edi,0C0000000h		;base address for system shared region
						;vxds are sleeping here...
		mov	ecx,0FFFFFh		;scan first 000FFFFFh bytes
seek:
		mov	al,01dh			;scan for 1dh
		mov	esi,offset32 sequence	;esi=pointer to opcodes of hotkey handler
scasb_protect:
		repne	scasb			;scan [edi] for al
scasb_endprotect:
		test	ecx,ecx			;counter=0 ?
		jz	exit			;exit
		push	edi			;save edi
		push	ecx			;and even ecx
		add	edi,4			;edi=edi+4
		mov	ecx,2			;compare 2 bytes of [esi] to [edi]
		repe	cmpsb			; "
		pop	ecx			;restore the great mr ecx
		pop	edi			;and his relative
		jnz	seek			;sequence was not sice's hotkey handler? -> seek
		add	edi,4			;byte-sequence/handler found
;int 3
		mov	word ptr [edi],09090H	;give the hotkey handler an evil touch
		xor ebx, ebx			;virtual machine handle
		mov eax, MB_SYSTEMMODAL		;message box flags
		mov ecx, OFFSET32 Message	;address of message
		mov edi, OFFSET32 Caption	;address of caption
		VxDcall SHELL_SYSMODAL_Message	;show message -> sice detected
exit:
;int 3
		clc
		ret				;return to loader

EHandler:
;int 3
		test ecx,ecx			;finished scanning?
		jz exit				;yup, exit
		dec ecx				;no, then dec counter
		inc edi				;inc pointer
		jmp scasb_protect		;continue scanning
		
EndProc OnDeviceInit

BeginProc OnDeviceDestroy	;if device is being unloaded by user


		clc
		ret
EndProc OnDeviceDestroy

BeginProc OnDeviceIoControl						;MUST be handled
		assume esi:ptr DIOCParams
		.IF [esi].dwIoControlCode == DIOC_Open
			xor	eax,eax
		.ENDIF
		ret
EndProc OnDeviceIoControl


VxD_PAGEABLE_CODE_ENDS


end