// GDTDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GDT.h"
#include "GDTDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGDTDlg dialog

CGDTDlg::CGDTDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGDTDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGDTDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGDTDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGDTDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGDTDlg, CDialog)
	//{{AFX_MSG_MAP(CGDTDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGDTDlg message handlers

BOOL CGDTDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGDTDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGDTDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGDTDlg::OnOk() 
{
	BYTE Gdt[6];
	Gdt[0] = 0;
	Gdt[1] = 0;
	Gdt[2] = 0;
	Gdt[3] = 0;
	Gdt[4] = 0;
	Gdt[5] = 0;
	
	BYTE Call_Ring0[6];
	Call_Ring0[0] = 0;
	Call_Ring0[1] = 0;
	Call_Ring0[2] = 0;
	Call_Ring0[3] = 0;
	Call_Ring0[4] = 0xF;
	Call_Ring0[5] = 0;

	BYTE Callgate[8];
	Callgate[0] = 0;
	Callgate[1] = 0;
	Callgate[2] = 0x28;
	Callgate[3] = 0;
	Callgate[4] = 0;
	Callgate[5] = 0xEC;
	Callgate[6] = 0;
	Callgate[7] = 0;

	DWORD Gate = (DWORD)Callgate;

	_asm
	{
		mov ax,ds
		test al,4  // o jak operan systm se jedn?
		je Not_Win9x  // skok = nejedn se o operan systm Windows 9x/Me
			
Win9x:
		mov eax,offset Ring0  // EAX = adresa sti programu, kter pob v Ring0
		mov word ptr [Callgate],ax  // nastaven adresy kdu, kter pob
			                        // v Ring0 do na callgate
		shr eax,16
		mov word ptr [Callgate+6],ax
			
		xor eax,eax
		sgdt fword ptr Gdt  // ulo GDT
		mov ebx,dword ptr [Gdt+2]  // EBX = adresa GDT
		sldt ax
		add ebx,eax  // zskn adresy Descriptoru
			
		mov al,[ebx+4]
		mov ah,[ebx+7]
		shl eax,16  // EAX = adresa LDT			
		mov ax,[ebx+2]  // zskn adresy Descriptoru callgate
			
		add eax,8
		mov edi,eax  // EDI = adresa v callgate pro aplikovn zmn
		mov esi,Gate  // ESI = adresa na callgate
		movsd  // pepis pvodn callgate 
		movsd   
			
		call fword ptr [Call_Ring0]  // --> Ring0
			
		xor eax,eax
		sub edi,8                      
		stosd  // obnoven pvodn callgate
		stosd
		jmp Ok
			
		/*******Ring0*******/
Ring0:
		mov eax,Dr7  // tato instrukce bude funkn pouze v Ring0
		retf  // --> Ring3
	}
Not_Win9x:
	MessageBox("Tato metoda funguje pouze ve Windows 9x/Me",NULL,MB_OK);
	return;
		
Ok:
	MessageBox("Pechod mezi Ring mdy probhl spn",NULL,MB_OK);
}
