// IDTDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IDT.h"
#include "IDTDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIDTDlg dialog

CIDTDlg::CIDTDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIDTDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIDTDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CIDTDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIDTDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CIDTDlg, CDialog)
	//{{AFX_MSG_MAP(CIDTDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIDTDlg message handlers

BOOL CIDTDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CIDTDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CIDTDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CIDTDlg::OnOk() 
{
	_asm
	{
		mov ax,ds
		test al,4  // o jak operan systm se jedn?
		je Not_Win9x  // skok = nejedn se o operan systm Windows 9x/Me
			
Win9x:
		push edx
		sidt [esp-2]  // naten IDT do zsobnku
		pop edx
		add edx,(3/*= INT 3*/*8)+4  // EDX = vektor nmi vybranho
			                        // peruen, tj. INT 3
		mov ebx,[edx]
		mov bx,word ptr [edx-4]  // uloen adresy obsluhy peruen pro
			                     // pozdj obnoven
		lea edi,Ring0
		mov [edx-4],di
		ror edi,16  // pesmrovn obsluhy peruen na n kd, kter
			        // m bet v Ring0
		mov [edx+2],di
			
		push ds  // uloen dleitch registr
		push es
		INT 3  // --> Ring0
		pop es  // obnoven registr
		pop ds
			
		mov [edx-4],bx  // obnoven pvodn obsluhy peruen
		ror ebx,16
		mov [edx+2],bx
		jmp Ok
			
		/*******Ring0*******/
Ring0:
		mov eax,Dr7  // tato instrukce bude funkn pouze v Ring0
		iretd  // --> Ring3
	}
Not_Win9x:
	MessageBox("Tato metoda funguje pouze ve Windows 9x/Me",NULL,MB_OK);
	return;
		
Ok:
	MessageBox("Pechod mezi Ring mdy probhl spn",NULL,MB_OK);
}
