// SimpleCRCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SimpleCRC.h"
#include "SimpleCRCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSimpleCRCDlg dialog

CSimpleCRCDlg::CSimpleCRCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSimpleCRCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSimpleCRCDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSimpleCRCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSimpleCRCDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSimpleCRCDlg, CDialog)
	//{{AFX_MSG_MAP(CSimpleCRCDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimpleCRCDlg message handlers

BOOL CSimpleCRCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSimpleCRCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSimpleCRCDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSimpleCRCDlg::OnOk() 
{
	__asm
	{
		mov eax,offset KonecDulObl
		sub eax,offset DulezitaOblast  // EAX = dlka kontrolovanch dat
			
		mov ecx,eax
		mov edi,offset DulezitaOblast  // adresa, odkud se m zat ve
			                           // vpotu kontrolnho soutu
		xor eax,eax  // vynulovn potebnch registr	
		xor ebx,ebx	
		xor esi,esi
			
Looop:
		mov al,byte ptr [edi]  // naten dat
		mul esi  // jednoduch nsoben
		add ebx,eax  // pidn vsledku do EBX        
		inc edi  // posunut se na dal bajt
		inc esi  // zvten ESI
		loop Looop
		// --> EBX = kontroln souet
		// hodnotu EBX nen teba ukldat, nsledujc kd ho nezmn

		/*******Nsledujc kd nem dnou funkci a je zde pouze pro to, aby
		z nj byl vypotn kontroln souet. Nen proto ani nutn, aby byl 
		sputn. Vy samozejm nahradte tato data tmi skutenmi, kter maj bt
		kontrolovna*******/
			
DulezitaOblast:
		nop  // zcela bezeln kd
		nop
		inc ebx
		dec ebx
		push eax
		pop eax
		nop
		nop

KonecDulObl:		
		cmp ebx,1463Fh  // porovnn sprvn a vypotan hodnoty 
			            // kontrolnho soutu
		je Ok
	}	
	MessageBox("Kd programu byl zmnn",NULL,MB_OK);
	return;
	
Ok:
	MessageBox("Kd programu nebyl zmnn",NULL,MB_OK);
}
