// MapFileAndCheckSumDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MapFileAndCheckSum.h"
#include "MapFileAndCheckSumDlg.h"
#include "imagehlp.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMapFileAndCheckSumDlg dialog

CMapFileAndCheckSumDlg::CMapFileAndCheckSumDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMapFileAndCheckSumDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMapFileAndCheckSumDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMapFileAndCheckSumDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMapFileAndCheckSumDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMapFileAndCheckSumDlg, CDialog)
	//{{AFX_MSG_MAP(CMapFileAndCheckSumDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapFileAndCheckSumDlg message handlers

BOOL CMapFileAndCheckSumDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMapFileAndCheckSumDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMapFileAndCheckSumDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMapFileAndCheckSumDlg::OnOk() 
{

	/*******V tomto ppad byl jako nzev kontrolovanho souboru zadn nzev samotnho programu a tak 
	program kontroluje svou vlastn integritu. Byla pouita kontrola s vyuitm promnn CheckSum 
	struktury IMAGE_OPTIONAL_HEADER32. Pokud si pejete kontrolovat integritu jinho PE souboru, 
	zadejte jeho nzev a zmte porovnn hodnot PECheckSum a VypocitanyCheckSum na porovnn 
	hodnoty VypocitanyCheckSum se sprvnou hodnotou kontrolnho	soutu souboru zskanou debuggingem.
	
	Dejte si pozor na zpsob sputn souboru MapFileAndCheckSum.exe - pokud spustte
	soubor z prosted Visual C++, program sm sebe nenajde (program se chov jako by byl sputn mimo 
	kompilovac adrese Debug a Release, ale ve skutenosti tomu tak nen). Radji soubor spuste pmo.*******/

	DWORD PECheckSum,VypocitanyCheckSum;
	MapFileAndCheckSum("MapFileAndCheckSum.exe",&PECheckSum,&VypocitanyCheckSum);  

	/*******Nsledujc rovnost bude platit pouze v ppad, e do promnn CheckSum struktury 
	IMAGE_OPTIONAL_HEADER32 ulote sprvnou hodnotu kontrolnho soutu (zskanou debuggingem)
	nap. pomoc hexadecimlnho nebo PE editoru. Piloen zkompilovan program byl takto upraven
	a tak se nedivte, e pi nov kompilaci bude chybn hlsit, e byl zmnn.*******/

	if (PECheckSum != VypocitanyCheckSum)
		MessageBox("Kd programu byl zmnn",NULL,MB_OK);
	else
		MessageBox("Kd programu nebyl zmnn",NULL,MB_OK);
}
