// PEvalidDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PEvalid.h"
#include "PEvalidDlg.h"
#include "imagehlp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPEvalidDlg dialog

CPEvalidDlg::CPEvalidDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPEvalidDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPEvalidDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPEvalidDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPEvalidDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPEvalidDlg, CDialog)
	//{{AFX_MSG_MAP(CPEvalidDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPEvalidDlg message handlers

BOOL CPEvalidDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPEvalidDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPEvalidDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPEvalidDlg::OnOk() 
{
	OPENFILENAME Open;
	char Soubor[512] = "";
	
	Open.lStructSize = 76; 
	Open.hwndOwner = NULL; 
	Open.hInstance = NULL; 
	Open.lpstrFilter = "Vechny soubory (*.*)\0*.*\0\0";
	Open.lpstrCustomFilter = NULL; 
	Open.nMaxCustFilter = NULL; 
	Open.nFilterIndex = NULL; 
	Open.lpstrFile = Soubor; 
	Open.nMaxFile = 512; 
	Open.lpstrFileTitle = NULL; 
	Open.nMaxFileTitle = NULL; 
	Open.lpstrInitialDir = NULL; 
	Open.lpstrTitle = "Prosm vyberte soubor, kter chcete zkontrolovat"; 
	Open.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_EXPLORER | OFN_PATHMUSTEXIST; 
	Open.nFileOffset = NULL; 
	Open.nFileExtension = NULL; 
	Open.lpstrDefExt = NULL; 
	Open.lCustData = NULL; 
	Open.lpfnHook = NULL; 
	Open.lpTemplateName = NULL;
	
	BOOL Vybrano = GetOpenFileName(&Open);
	if (!Vybrano)
		return;

	PIMAGE_NT_HEADERS pImageNT;
	DWORD NOBR;
	
	HANDLE File = CreateFile(Soubor,GENERIC_READ,FILE_SHARE_READ,NULL, OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);  // zskn handlu souboru
	if (File == INVALID_HANDLE_VALUE)
	{
		MessageBox("Soubor nelze otevt pro ten!",NULL,MB_OK | MB_ICONINFORMATION);
		return;
	}
	
	DWORD FileSize = GetFileSize(File,NULL);
	BYTE *pMem = new BYTE[FileSize];  // alokace pamti
	ReadFile(File,pMem,FileSize,&NOBR,NULL);  // naten souboru do pamti
	pImageNT = ImageNtHeader((VOID*)pMem);  // zskn struktury IMAGE_NT_HEADERS

	if (pImageNT == 0)  // jedn se o PE soubor?
	{
		MessageBox("Soubor nem platn PE formt!",NULL,MB_OK | MB_ICONINFORMATION); 
		CloseHandle(File);
		delete pMem;
		return;
	}
	MessageBox("Soubor m platn PE formt!",NULL,MB_OK | MB_ICONINFORMATION); 
	
	CloseHandle(File);
	delete pMem;
}
