// PEkoderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PEkoder.h"
#include "PEkoderDlg.h"
#include "imagehlp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPEkoderDlg dialog

CPEkoderDlg::CPEkoderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPEkoderDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPEkoderDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPEkoderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPEkoderDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPEkoderDlg, CDialog)
	//{{AFX_MSG_MAP(CPEkoderDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPEkoderDlg message handlers

BOOL CPEkoderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPEkoderDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CPEkoderDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

DWORD CODE_SIZE = 0;
DWORD CODE_START = 0;
DWORD VAR_START = 0;
DWORD OTHER_SIZE = sizeof IMAGE_TLS_DIRECTORY32 + 0x61;

static DWORD VAR[3];

void __stdcall AddedCode()
{
	__asm
	{
		mov eax,offset CodeEnd
		sub eax,offset CodeStart
		mov CODE_SIZE,eax
		mov eax,offset CodeStart
		mov CODE_START,eax
		mov eax,offset VariablesStart
		sub eax,offset CodeStart
		mov VAR_START,eax
		
		jmp CodeEnd
	}
	
	/******Reijn kd, kter bude vloen do souboru******/
CodeStart:
		__asm
		{
			push ebx
			push ecx
			push edx
			push esi
			push edi
			push ebp
				
			call CallMe
				
CallMe:
			pop ebp
			sub ebp,offset CallMe
				
			mov ebx,offset CodeStart
			add ebx,ebp
			sub ebx,[ebp+NewEntryPointRVA]
			mov [ebp+ImageBase],ebx
				
			mov edx,[ebx+3Ch]  
			add edx,[ebp+ImageBase]
			mov [ebp+Buffer],edx
			add edx,6
			mov bx,[edx]
			mov word ptr [ebp+SecNum],bx
			add edx,7Ah 
			mov edx,[edx]
			add edx,[ebp+ImageBase]
			
			add edx,16 
			mov ecx,dword ptr [edx]
			add ecx,[ebp+ImageBase] 
			mov edx,[ecx]
			mov [ebp+_LoadLibrary],edx
				
			add ecx,4
			mov edx,[ecx] 
			mov [ebp+_GetProcAddress],edx 
				
			mov eax,[ebp+OrgEntryPointRVA]
			add eax,[ebp+ImageBase]
			mov [ebp+OrgEP],eax
				
			/*******Deifrovn sekc*******/
			xor ecx,ecx
			mov edi,[ebp+SecNum]
			mov eax,[ebp+Buffer]
			add eax,0F8h
				
MainDecodeLoop:
			cmp di,cx
			jz DekodovaniHotovo
				
			push edi
			mov ebx,[eax]
			cmp ebx,77656E2Eh 
			jz NoDecoding
			cmp ebx,7273722Eh 
			jz NoDecoding
			cmp ebx,63727372h 
			jz NoDecoding
			cmp ebx,6C65722Eh 
			jz NoDecoding
			cmp ebx,6F6C6572h 
			jz NoDecoding
			cmp ebx,6164652Eh 
			jz NoDecoding
			cmp ebx,736C742Eh 
			jz NoDecoding
				
			add eax,8
			mov edi,[eax] 
			add eax,4
			mov ebx,[eax] 
			add eax,4
			mov edx,[eax] 
			add eax,4
			mov esi,[eax] 
				
			cmp esi,0
			jz SectionDecoded
			cmp edx,0
			jz SectionDecoded
				
			cmp edi,edx
			jnl TakeSizeOfRawData
			mov edx,edi
				
TakeSizeOfRawData:
			mov esi,[ebp+ImageBase]
			add ebx,esi
			call SimpleCrypt
			jmp SectionDecoded
				
NoDecoding:
			add eax,14h
				
SectionDecoded:
			add eax,14h
			inc cx
			pop edi
			jmp MainDecodeLoop
				
DekodovaniHotovo:
			mov edx,[ebp+OrgIT] 
			add edx,[ebp+ImageBase] 
			mov eax,[edx]	
			add eax,[ebp+ImageBase] 
			mov [ebp+OrgFirstThunk],eax 
			add edx,12	
			mov eax,[edx] 
			add eax,[ebp+ImageBase]
			mov [ebp+Name1],eax 
			add edx,4
			mov eax,[edx] 
			add eax,[ebp+ImageBase]
			mov [ebp+FirstThunk],eax 
			add edx,4
			mov [ebp+Buffer],edx 
				
			/*******Zpracovn importovanch funkc*******/
MainITLoop:
			mov ecx,[ebp+ImageBase]
			cmp [ebp+FirstThunk],ecx 
			jz MainITEnd 
				
			mov ebx,[ebp+Name1]
			push ebx 
			mov eax,[ebp+_LoadLibrary]
			call eax 
			mov ebx,eax 
				
			mov ecx,[ebp+ImageBase]
			cmp [ebp+OrgFirstThunk],ecx 
			jnz Nothing
			mov eax,[ebp+FirstThunk]
			mov [ebp+OrgFirstThunk],eax
				
Nothing:
			mov ecx,[ebp+OrgFirstThunk]
			mov eax,[ecx]
			mov [ebp+OrgThunkData],eax
				
SecondITLoop:
			cmp [ebp+OrgThunkData],0
			jz OrgThunkJMP
			mov eax,[ebp+OrgThunkData]
			and eax,IMAGE_ORDINAL_FLAG32
			cmp eax,0
			jnz Ordinal
				
			mov ecx,[ebp+OrgThunkData]
			mov edx,[ebp+ImageBase]
			add edx,2
			add ecx,edx
			mov edi,ecx
			push edi
			push ebx
			mov eax,[ebp+_GetProcAddress]
			call eax
			jmp Jump
				
Ordinal:
			mov eax,[ebp+OrgThunkData]
			sub eax,80000000h
			push eax
			push ebx
			mov eax,[ebp+_GetProcAddress]
			call eax
				
Jump:
			mov esi,[ebp+FirstThunk]
			mov dword ptr [esi],eax
			mov ecx,[ebp+OrgFirstThunk]
			mov edx,[ebp+FirstThunk]
			add ecx,4
			add edx,4
			mov [ebp+OrgFirstThunk],ecx
			mov [ebp+FirstThunk],edx
			mov eax,[ecx]
			mov [ebp+OrgThunkData],eax
			jmp SecondITLoop
				
OrgThunkJMP:
			mov edx,[ebp+Buffer]
			mov eax,[edx]
			add eax,[ebp+ImageBase]
			mov [ebp+OrgFirstThunk],eax
			add edx,12
			mov eax,[edx]
			add eax,[ebp+ImageBase]
			mov [ebp+Name1],eax
			add edx,4
			mov eax,[edx]
			add eax,[ebp+ImageBase]
			mov [ebp+FirstThunk],eax
			add edx,4
			mov [ebp+Buffer],edx
			jmp MainITLoop
				
MainITEnd:
			/*******Ukzka voln API funkce*******/
			mov eax,[ebp+_LoadLibrary]
			mov ecx,offset User32
			add ecx,ebp 
			push ecx
			call eax 
			mov ebx,eax 
				
			mov ecx,offset Funkce
			add ecx,ebp 
				
			mov eax,[ebp+_GetProcAddress]
			push ecx 
			push ebx 
			call eax 
			
			push 40h 
			call eax 
				
			mov eax,[ebp+OrgEP]
			pop ebp
			pop edi
			pop esi
			pop edx
			pop ecx
			pop ebx
				
			/*******Skok na pvodn Program Entry Point*******/
			jmp eax
				
			/*******Jednoduch ifrovac algoritmus*******/
SimpleCrypt:
			push ecx
			push eax
			xor ecx,ecx
				
DecodeLoop:
			cmp edx,ecx
			jz DecodeDone
			mov al,[ebx]
			xor al,0ABh
			mov [ebx],al
			inc ebx
			inc ecx
			jmp DecodeLoop
				
DecodeDone:
			pop eax
			pop ecx
				
			ret
				
			/*******Promnn*******/
VariablesStart:
			
			/*******Inicializan promnn********/
NewEntryPointRVA:
			__emit 0
			__emit 0 
			__emit 0
			__emit 0
				
OrgEntryPointRVA:
			__emit 0
			__emit 0
			__emit 0
			__emit 0
				
OrgIT:
			__emit 0
			__emit 0
			__emit 0
			__emit 0
				
			/*******Promnn, kter budou zaplnny a za bhu programu********/
_LoadLibrary:
			__emit 0
			__emit 0
			__emit 0
			__emit 0
				
_GetProcAddress:
			__emit 0
			__emit 0
			__emit 0
			__emit 0
				
ImageBase:
			__emit 0
			__emit 0 
			__emit 0
			__emit 0
				
OrgEP:
			__emit 0
			__emit 0
			__emit 0
			__emit 0
				
SecNum:
			__emit 0
			__emit 0
				
OrgFirstThunk:
			__emit 0
			__emit 0
			__emit 0
			__emit 0
				
FirstThunk:
			__emit 0
			__emit 0
			__emit 0
			__emit 0
				
Name1:
			__emit 0
			__emit 0
			__emit 0
			__emit 0
				
OrgThunkData:
			__emit 0
			__emit 0
			__emit 0
			__emit 0
				
Buffer:
			__emit 0
			__emit 0
			__emit 0
			__emit 0
				
			/*******Promnn potebn pro voln API funkce*******/
Funkce:
			__emit 0x4D
			__emit 0x65
			__emit 0x73
			__emit 0x73
			__emit 0x61
			__emit 0x67
			__emit 0x65
			__emit 0x42
			__emit 0x65
			__emit 0x65
			__emit 0x70
			__emit 0
				
User32:
			__emit 0x75
			__emit 0x73
			__emit 0x65
			__emit 0x72
			__emit 0x33
			__emit 0x32
			__emit 0x2E
			__emit 0x64
			__emit 0x6C
			__emit 0x6C
			__emit 0
	}
	
CodeEnd:;
}

DWORD CPEkoderDlg::PEAlign(DWORD Num,DWORD AlignTo)
{
	/*******Funkce pro vpoet zarovnn*******/
	while(Num % AlignTo != 0)
	{	
		Num++;
	}
	return Num;
}

void CPEkoderDlg::WritePEFile(LPVOID pMem,HANDLE File,DWORD Size)
{
	/*******Funkce pro zpis obsahu pamti do souboru*******/
	DWORD BytesWritten;
	
	SetFilePointer(File,0,NULL,FILE_BEGIN);
	WriteFile(File,pMem,Size,&BytesWritten,NULL);
	SetFilePointer(File,Size,NULL,FILE_BEGIN);
	SetEndOfFile(File);
}

void CPEkoderDlg::ProcessTLS(BYTE *pMem,DWORD VAddress,PIMAGE_NT_HEADERS pImageNT,DWORD FileSize,DWORD Offset)
{
	/*******Funkce pro zpracovn TLS*******/
	memcpy((VOID*)(pMem+FileSize+CODE_SIZE+0x61),(pMem+Offset),sizeof IMAGE_TLS_DIRECTORY32);
	pImageNT->OptionalHeader.DataDirectory[9].VirtualAddress = VAddress+CODE_SIZE+0x61;
}

void CPEkoderDlg::ProcessPE(char* zdroj,char* cil)
{
	PIMAGE_NT_HEADERS pImageNT;
	DWORD NOBR;
	
	/*******Zskn handlu zdrojovho souboru*******/
	HANDLE File = CreateFile(zdroj,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL); 
	if (File == INVALID_HANDLE_VALUE)
	{
		MessageBox("Soubor nelze otevt pro ten!",NULL,MB_OK | MB_ICONINFORMATION);
		return;
	}
	
	/*******Naten globlnch promennch*******/
	AddedCode();
	
	/*******Naten souboru do pamti a jej vyitn*******/
	DWORD FileSize = GetFileSize(File,NULL);
	if (FileSize == 0)
	{
		MessageBox("Soubory s nulovou velikost nejsou povoleny!",NULL,MB_OK | MB_ICONINFORMATION);
		CloseHandle(File);
		return;
	}
	
	DWORD Size = FileSize+CODE_SIZE+OTHER_SIZE+0x1000;
	BYTE *pMem = new BYTE[Size];
	for (DWORD i = 0; i < Size; i++)
	{
		pMem[i] = 0;
	}
	
	ReadFile(File,pMem,FileSize,&NOBR,NULL);
	pImageNT = ImageNtHeader((VOID*)pMem); 
	
	/*******Oven PE formtu*******/
	if (pImageNT == 0)
	{
		MessageBox("Soubor nem platn PE formt!",NULL,MB_OK | MB_ICONINFORMATION);
		CloseHandle(File);
		delete pMem;
		return;
	}
	
	/*******Oven ptomnosti tabulky import*******/
	DWORD ITRVA = pImageNT->OptionalHeader.DataDirectory[1].VirtualAddress;
	if (ITRVA == 0)
	{
		MessageBox("dn importovan funkce?!",NULL,MB_OK | MB_ICONINFORMATION);
		CloseHandle(File);
		delete pMem;
		return;
	}
	
	/*******Pidn nov sekce, jej zaplnn a pesmrovn potebnch	hodnot*******/
	DWORD NewSize = AddSection(pMem,pImageNT);
	if (NewSize == 0)
	{
		CloseHandle(File);
		delete pMem;
		return;
	}
	
	/*******Zaifrovn sekc v souboru*******/
	CryptPE(pImageNT,pMem);
	
	/*******Zskn handlu clovho souboru*******/
	HANDLE NewFile = CreateFile(cil,GENERIC_WRITE | GENERIC_READ,FILE_SHARE_WRITE | FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	if (NewFile == INVALID_HANDLE_VALUE)
	{
		MessageBox("Soubor nelze vytvoit!",NULL,MB_OK | MB_ICONINFORMATION);
		CloseHandle(File);
		delete pMem;
		return;
	}
	
	/*******Uloen souboru*******/
	WritePEFile(pMem,NewFile,NewSize);
	MessageBox("Hotovo!",NULL,MB_OK | MB_ICONINFORMATION);
	
	CloseHandle(File);
	CloseHandle(NewFile);
	delete pMem;
}

IMAGE_SECTION_HEADER CPEkoderDlg::RvaToSection(PIMAGE_NT_HEADERS pImageNT,BYTE *pMem,DWORD AdrOfSecTable,BOOL AdjustChar)
{
	/*******Funkce pro zskn parametr sekce*******/
	PIMAGE_SECTION_HEADER pSection;
	IMAGE_SECTION_HEADER Section;
	DWORD vaddr;	
	
	memcpy(&vaddr,(VOID*)(AdrOfSecTable+12),sizeof DWORD);
	pSection = ImageRvaToSection(pImageNT,pMem,vaddr);
	if (pSection == 0)
	{
		/*******Uloen parametr sekce do promnnch*******/
		DWORD vsize,raddr,rsize,characteristics;

		memcpy(&vsize,(VOID*)(AdrOfSecTable+8),sizeof DWORD);
		memcpy(&rsize,(VOID*)(AdrOfSecTable+16),sizeof DWORD);
		memcpy(&raddr,(VOID*)(AdrOfSecTable+20),sizeof DWORD);
		memcpy(&characteristics,(VOID*)(AdrOfSecTable+36),sizeof DWORD);
		
		Section.VirtualAddress = vaddr;
		Section.Misc.VirtualSize = vsize;
		Section.PointerToRawData = raddr;
		Section.SizeOfRawData = rsize; 
		
		if (AdjustChar)
			Section.Characteristics = characteristics | 0x80000000;

		return Section;
	}
	if (AdjustChar)
		pSection->Characteristics = pSection->Characteristics | 0x80000000;

	Section = *pSection;	
	return Section;
}

void  CPEkoderDlg::SimpleCrypt(BYTE *pInput,DWORD lSize)
{
	/*******Jednoduch ifrovac algoritmus*******/
	for (DWORD lCount = 0; lCount < lSize ; lCount++,pInput++)
	{
		*pInput ^= 0xAB;
	}
}

void CPEkoderDlg::AssembleIT(BYTE *pMem,DWORD NewSectionRAW,DWORD NewSectionVA,PIMAGE_NT_HEADERS pImageNT)
{
	/*******Funkce pro vytvoen nov tabulky import*******/
	DWORD *Name = new DWORD;
	DWORD *FirstThunk = new DWORD;	
	DWORD *ThunkLoadLibrary = new DWORD;
	DWORD *ThunkGetProcAddress = new DWORD;
	
	NewSectionRAW += CODE_SIZE;
	NewSectionVA += CODE_SIZE;
	
	/*******Vytvoen struktur tabulky import*******/
	*Name = NewSectionVA+2*sizeof IMAGE_IMPORT_DESCRIPTOR+3*sizeof IMAGE_THUNK_DATA+12+1+14+1+2*sizeof WORD;
	*FirstThunk = NewSectionVA+2*sizeof IMAGE_IMPORT_DESCRIPTOR;
	
	memcpy((VOID*)(pMem+NewSectionRAW+12),Name,sizeof DWORD);
	memcpy((VOID*)(pMem+NewSectionRAW+16),FirstThunk,sizeof DWORD);
	
	*ThunkLoadLibrary = NewSectionVA+2*sizeof IMAGE_IMPORT_DESCRIPTOR+3*sizeof IMAGE_THUNK_DATA;
	*ThunkGetProcAddress = NewSectionVA+2*sizeof IMAGE_IMPORT_DESCRIPTOR+3*sizeof IMAGE_THUNK_DATA+sizeof WORD+12+1;
	
	memcpy((VOID*)(pMem+NewSectionRAW+2*sizeof IMAGE_IMPORT_DESCRIPTOR),(VOID*)ThunkLoadLibrary,sizeof IMAGE_THUNK_DATA);
	memcpy((VOID*)(pMem+NewSectionRAW+2*sizeof IMAGE_IMPORT_DESCRIPTOR+sizeof IMAGE_THUNK_DATA),(VOID*)ThunkGetProcAddress,sizeof IMAGE_THUNK_DATA);
	
	/*******LoadLibraryA*******/
	DWORD Adresa = NewSectionRAW+2*sizeof IMAGE_IMPORT_DESCRIPTOR+3*sizeof IMAGE_THUNK_DATA+sizeof WORD;
	pMem[Adresa] = 0x4C; 
	pMem[Adresa+1] = 0x6F;	
	pMem[Adresa+2] = 0x61;	
	pMem[Adresa+3] = 0x64;	
	pMem[Adresa+4] = 0x4C;	
	pMem[Adresa+5] = 0x69;	
	pMem[Adresa+6] = 0x62;	
	pMem[Adresa+7] = 0x72;	
	pMem[Adresa+8] = 0x61;	
	pMem[Adresa+9] = 0x72;	
	pMem[Adresa+10] = 0x79;	
	pMem[Adresa+11] = 0x41;	
	
	/*******GetProcAddress*******/
	Adresa = NewSectionRAW+2*sizeof IMAGE_IMPORT_DESCRIPTOR+3*sizeof IMAGE_THUNK_DATA+2*sizeof WORD+12+1;
	pMem[Adresa] = 0x47;
	pMem[Adresa+1] = 0x65;	
	pMem[Adresa+2] = 0x74;	
	pMem[Adresa+3] = 0x50;	
	pMem[Adresa+4] = 0x72;	
	pMem[Adresa+5] = 0x6F;	
	pMem[Adresa+6] = 0x63;	
	pMem[Adresa+7] = 0x41;	
	pMem[Adresa+8] = 0x64;	
	pMem[Adresa+9] = 0x64;	
	pMem[Adresa+10] = 0x72;	
	pMem[Adresa+11] = 0x65;	
	pMem[Adresa+12] = 0x73;	
	pMem[Adresa+13] = 0x73;	
	
	/*******kernel32.dll*******/
	Adresa = NewSectionRAW+2*sizeof IMAGE_IMPORT_DESCRIPTOR+3*sizeof IMAGE_THUNK_DATA+2*sizeof WORD+12+1+14+1;	
	pMem[Adresa] = 0x6B; 
	pMem[Adresa+1] = 0x65;	
	pMem[Adresa+2] = 0x72;	
	pMem[Adresa+3] = 0x6E;	
	pMem[Adresa+4] = 0x65;	
	pMem[Adresa+5] = 0x6C;	
	pMem[Adresa+6] = 0x33;	
	pMem[Adresa+7] = 0x32;	
	pMem[Adresa+8] = 0x2E;	
	pMem[Adresa+9] = 0x64;	
	pMem[Adresa+10] = 0x6C;	
	pMem[Adresa+11] = 0x6C;	
	
	delete ThunkGetProcAddress;
	delete ThunkLoadLibrary;
	delete FirstThunk;
	delete Name;
}

void CPEkoderDlg::CryptPE(PIMAGE_NT_HEADERS pImageNT,BYTE *pMem)
{
	/*******Funkce pro zaifrovan sekc v souboru*******/
	IMAGE_SECTION_HEADER *pSection = new IMAGE_SECTION_HEADER;
	DWORD SecNum = pImageNT->FileHeader.NumberOfSections;
	DWORD AdrOfSecTable;
	
	for (DWORD i = 0; i < SecNum; i++)
	{
		AdrOfSecTable = (DWORD)pImageNT+(sizeof IMAGE_NT_HEADERS)+i*(sizeof IMAGE_SECTION_HEADER);
		*pSection = RvaToSection(pImageNT,pMem,AdrOfSecTable,FALSE);
		if (*(LPDWORD)pSection->Name != 0x77656E2E /*".new"*/ && 
			*(LPDWORD)pSection->Name != 0x7273722E /*".rsr"*/ && 
			*(LPDWORD)pSection->Name != 0x63727372 /*"rsrc"*/ && 
			*(LPDWORD)pSection->Name != 0x6C65722E /*".rel"*/ && 
			*(LPDWORD)pSection->Name != 0x6F6C6572 /*"relo"*/ && 
			*(LPDWORD)pSection->Name != 0x6164652E /*".eda"*/ && 
			*(LPDWORD)pSection->Name != 0x736C742E /*.tls*/ && 
			pSection->PointerToRawData != 0 && pSection->SizeOfRawData != 0 )
		{
			DWORD Velikost = (pSection->Misc.VirtualSize < pSection->SizeOfRawData ? pSection->Misc.VirtualSize : pSection->SizeOfRawData);
			SimpleCrypt(pMem+pSection->PointerToRawData,Velikost);
		}
	}
	delete pSection;
}


DWORD CPEkoderDlg::AddSection(BYTE *pMem,PIMAGE_NT_HEADERS pImageNT)
{
	/*******Funkce pro pidn a zaplnn nov sekce a pro pesmrovn	patinch hodnot*******/
	IMAGE_SECTION_HEADER *pSection = new IMAGE_SECTION_HEADER;
	DWORD SecNum = pImageNT->FileHeader.NumberOfSections;
	DWORD VelSekce = sizeof IMAGE_SECTION_HEADER;
	DWORD Velikost = (SecNum+1)*VelSekce;
	DWORD CelkVelikost = (DWORD)pImageNT-(DWORD)pMem+Velikost+sizeof IMAGE_NT_HEADERS;  
	DWORD VelHlavicek = pImageNT->OptionalHeader.SizeOfHeaders;
	
	/*******Kontrola msta v tabulce sekc*******/
	if (CelkVelikost > VelHlavicek)
	{
		MessageBox("Nedostatek msta v tabulce sekc",NULL,MB_OK | MB_ICONINFORMATION);
		return 0;
	}
	
	/*******Zjitn parametr posledn sekce*******/
	DWORD AdrOfSecTable;
	for (DWORD i = 0; i < SecNum; i++)
	{
		AdrOfSecTable = (DWORD)pImageNT+sizeof IMAGE_NT_HEADERS+i*(sizeof IMAGE_SECTION_HEADER);
		*pSection = RvaToSection(pImageNT,pMem,AdrOfSecTable,TRUE);
	}
	
	unsigned char Name1[8] = ".new";
	DWORD *VirtualAddress = new DWORD;
	DWORD *VirtualSize = new DWORD;
	DWORD *SizeOfRawData = new DWORD;
	DWORD *PointerToRawData = new DWORD;
	DWORD *Characteristics = new DWORD;
	
	/*******Vpoet parametr nov sekce*******/
	*VirtualAddress = PEAlign(pSection->VirtualAddress+pSection->Misc.VirtualSize,pImageNT->OptionalHeader.SectionAlignment);
	*VirtualSize = CODE_SIZE+OTHER_SIZE;
	*SizeOfRawData = PEAlign(CODE_SIZE+OTHER_SIZE,pImageNT->OptionalHeader.FileAlignment);
	*Characteristics = 0xE00000E0;
	*PointerToRawData = pSection->PointerToRawData+pSection->SizeOfRawData;
	
	/*******Zaplnn pole promnnch*******/
	VAR[0] = *VirtualAddress;
	VAR[1] = pImageNT->OptionalHeader.AddressOfEntryPoint;
	VAR[2] = pImageNT->OptionalHeader.DataDirectory[1].VirtualAddress;
	
	DWORD RealSize = *SizeOfRawData+*PointerToRawData; 
	DWORD Adresa = AdrOfSecTable+sizeof IMAGE_SECTION_HEADER;
	
	/*******Zpis deklarace nov sekce do tabulky sekc*******/
	memcpy((VOID*)(Adresa),Name1,sizeof Name1);
	memcpy((VOID*)(Adresa+8),(VOID*)VirtualSize,sizeof DWORD);
	memcpy((VOID*)(Adresa+12),(VOID*)VirtualAddress,sizeof DWORD);
	memcpy((VOID*)(Adresa+16),(VOID*)SizeOfRawData,sizeof DWORD);
	memcpy((VOID*)(Adresa+20),(VOID*)PointerToRawData,sizeof DWORD);
	memcpy((VOID*)(Adresa+36),(VOID*)Characteristics,sizeof DWORD);
	
	/*******Pidn reijnho kdu*******/
	memcpy((VOID*)(pMem+*PointerToRawData),(VOID*)(CODE_START),CODE_SIZE);
	
	/*******Pidn promnnch******/
	memcpy((VOID*)(pMem+*PointerToRawData+VAR_START),(VOID*)VAR,sizeof VAR);
	
	/*******Korekce hodnot***********/
	pImageNT->FileHeader.NumberOfSections += 1;
	pImageNT->OptionalHeader.SizeOfImage += *SizeOfRawData;
	pImageNT->OptionalHeader.SizeOfCode += *SizeOfRawData;
	pImageNT->OptionalHeader.SizeOfInitializedData += *SizeOfRawData;
	
	/*******Zpracovn tabulky import*******/
	AssembleIT(pMem,*PointerToRawData,*VirtualAddress,pImageNT);
	pImageNT->OptionalHeader.DataDirectory[1].VirtualAddress = *VirtualAddress+CODE_SIZE;
	
	/*******TLS*******/
	if(pImageNT->OptionalHeader.DataDirectory[9].VirtualAddress != 0)
	{
		PIMAGE_SECTION_HEADER Section = ImageRvaToSection(pImageNT,pMem,pImageNT->OptionalHeader.DataDirectory[9].VirtualAddress);
		DWORD Offset = pImageNT->OptionalHeader.DataDirectory[9].VirtualAddress-Section->VirtualAddress+Section->PointerToRawData;
		
		ProcessTLS(pMem,*VirtualAddress,pImageNT,*PointerToRawData,Offset);
	}
	
	/*******Pesmrovn Program Entry Pointu*******/
	pImageNT->OptionalHeader.AddressOfEntryPoint = *VirtualAddress;
	
	delete Characteristics;
	delete PointerToRawData;
	delete SizeOfRawData;
	delete VirtualSize;
	delete VirtualAddress;
	delete pSection;
	
	return RealSize;
}

void CPEkoderDlg::OnOk() 
{
	/*******Vbr zdrojovho a clovho souboru*******/
	OPENFILENAME Open;
	char Buffer[512] = "";
	
	Open.lStructSize = 76; 
	Open.hwndOwner = NULL; 
	Open.hInstance = NULL; 
	Open.lpstrFilter = "Soubory EXE (*.EXE)\0*.EXE\0\0";
	Open.lpstrCustomFilter = NULL; 
	Open.nMaxCustFilter = NULL; 
	Open.nFilterIndex = NULL; 
	Open.lpstrFile = Buffer; 
	Open.nMaxFile = 512; 
	Open.lpstrFileTitle = NULL; 
	Open.nMaxFileTitle = NULL; 
	Open.lpstrInitialDir = NULL; 
	Open.lpstrTitle = "Prosm vyberte soubor, kter chcete zaifrovat"; 
	Open.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_EXPLORER | OFN_PATHMUSTEXIST; 
	Open.nFileOffset = NULL; 
	Open.nFileExtension = NULL; 
	Open.lpstrDefExt = NULL; 
	Open.lCustData = NULL; 
	Open.lpfnHook = NULL; 
	Open.lpTemplateName = NULL;
	
	BOOL Vybrano = GetOpenFileName(&Open);
	
	if (Vybrano)
	{
		OPENFILENAME Open2;
		char Buffer2[512] = "";
		
		Open2.lStructSize = 76; 
		Open2.hwndOwner = NULL; 
		Open2.hInstance = NULL; 
		Open2.lpstrFilter = "Vechny soubory (*.*)\0*.*\0\0";
		Open2.lpstrCustomFilter = NULL; 
		Open2.nMaxCustFilter = NULL; 
		Open2.nFilterIndex = NULL; 
		Open2.lpstrFile = Buffer2; 
		Open2.nMaxFile = 512; 
		Open2.lpstrFileTitle = NULL; 
		Open2.nMaxFileTitle = NULL; 
		Open2.lpstrInitialDir = NULL; 
		Open2.lpstrTitle = "Prosm zvolte lon soubor"; 
		Open2.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY | OFN_EXPLORER; 
		Open2.nFileOffset = NULL; 
		Open2.nFileExtension = NULL; 
		Open2.lpstrDefExt = NULL; 
		Open2.lCustData = NULL; 
		Open2.lpfnHook = NULL; 
		Open2.lpTemplateName = NULL;
		
		BOOL Vybrano2 = GetOpenFileName(&Open2);
		
		if(Vybrano2)
		{
			ProcessPE(Buffer,Buffer2);
		}
	}
}

