// BoundsCheckerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BoundsChecker.h"
#include "BoundsCheckerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBoundsCheckerDlg dialog

CBoundsCheckerDlg::CBoundsCheckerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBoundsCheckerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBoundsCheckerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBoundsCheckerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBoundsCheckerDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBoundsCheckerDlg, CDialog)
	//{{AFX_MSG_MAP(CBoundsCheckerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBoundsCheckerDlg message handlers

BOOL CBoundsCheckerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBoundsCheckerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBoundsCheckerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBoundsCheckerDlg::OnOk() 
{
	__asm
	{
		push offset MyHandler  // adresa handleru
		push dword ptr fs:[0]  // uloen adresy pedchozho handleru
		mov fs:[0],esp  // instalace
			
		push ebp  // uloen hodnoty EBP
		mov ebp,4243484Bh  // EBP = (ASCII)BCHK = BoundsChecker
		mov eax,4  // EAX obsahuje poadovanou funkci
		INT 3  // voln BoundsCheckeru - pokud nen SoftICE aktivn,
	           // zpracuje voln systm a dojde tak k chyb, kterou zpracuje
			   // MyHandler
		nop  // NOP je zde kvli kompatibilit mezi Win32 systmy
		     // pi vyvoln chyby instrukc INT 3 ukazuje EIP(NT/2000/XP) na 
			 // INT 3, ale EIP(9x/Me) na NOP
		pop ebp  // obnoven EBP
		pop dword ptr fs:[0]  // obnoven pvodnho handleru
		add esp,4  // korekce zsobnku
			
		cmp eax,4  // pokud zpracoval INT 3 SoftICE bude hodnota EAX zmnna
		jz No_SoftICE  // v opanm ppad zpracoval INT 3 systm nebo dolo
		               // k njak neoekvan chyb
		jmp SoftICE
			
MyHandler:
		// pro snadnj pstup nateme struktury CONTEXT a EXCEPTION_RECORD
		// nap. do ECX a EDX
		mov edx,[esp+0Ch]  // CONTEXT
		mov ecx,[esp+4]   // EXCEPTION_RECORD	
		mov eax,80000003h  // EAX = slo chyby, kterou vyvol instrukce 
                           // INT 3 - STATUS_BREAKPOINT(80000003h)
		mov ecx,[ecx]  // ECX = slo chyby, kter prv vznikla
		sub eax,ecx  // porovnn hodnot EAX a ECX
		je Ok  // pokud se sla chyb shoduj, meme pokraovat
		sub eax,eax  // dolo k jin chyb, kterou handler nebude zpracovvat
		inc eax  // ExceptionContinueSearch
		jmp Konec
			
Ok:
		add dword ptr [edx+0B8h],1  // hodnota EIP je zvtena o 1 bajt
			                        // tj. o dlku instrukce INT 3(CCh)
			                        // tm bude tato instrukce peskoena a
			                        // chyba se tak nebude opakovat
		sub eax,eax  // ExceptionContinueExecution
			
Konec:
		ret
	}
No_SoftICE:
	MessageBox("SoftICE nenalezen",NULL,MB_OK);
	return;
		
SoftICE:
	MessageBox("SoftICE nalezen",NULL,MB_OK);		
}
