// BoundsCheckerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BoundsChecker.h"
#include "BoundsCheckerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBoundsCheckerDlg dialog

CBoundsCheckerDlg::CBoundsCheckerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBoundsCheckerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBoundsCheckerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBoundsCheckerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBoundsCheckerDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBoundsCheckerDlg, CDialog)
	//{{AFX_MSG_MAP(CBoundsCheckerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBoundsCheckerDlg message handlers

BOOL CBoundsCheckerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBoundsCheckerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBoundsCheckerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

long __stdcall MyHandler(_EXCEPTION_POINTERS *ExceptionInfo)
{
	if (ExceptionInfo->ExceptionRecord->ExceptionCode == 0x80000003)
	{
		ExceptionInfo->ContextRecord->Eip += 1;  // opraven chyby
		return EXCEPTION_CONTINUE_EXECUTION;
	}
	return EXCEPTION_CONTINUE_SEARCH;
}

void CBoundsCheckerDlg::OnOk() 
{
    LPTOP_LEVEL_EXCEPTION_FILTER Predchozi = SetUnhandledExceptionFilter(MyHandler);

	__asm
	{
		push ebp  // uloen hodnoty EBP
		mov ebp,4243484Bh  // EBP = (ASCII)BCHK=BoundsChecker
		mov eax,4  // EAX obsahuje poadovanou funkci
		INT 3  // voln BoundsCheckeru - pokud nen SoftIce
               // aktivn, dojde k chyb, kterou zpracuje MyHandler
		nop
		pop ebp  // obnoven EBP
		cmp eax,4
		jz No_SoftICE
	}
	MessageBox("SoftICE nalezen",NULL,MB_OK);
	SetUnhandledExceptionFilter(Predchozi);
	return;

No_SoftICE:
	MessageBox("SoftICE nenalezen ",NULL,MB_OK);
	SetUnhandledExceptionFilter(Predchozi);
}
