// RegistryDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Registry.h"
#include "RegistryDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRegistryDlg dialog

CRegistryDlg::CRegistryDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRegistryDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRegistryDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRegistryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRegistryDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRegistryDlg, CDialog)
	//{{AFX_MSG_MAP(CRegistryDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRegistryDlg message handlers

BOOL CRegistryDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRegistryDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRegistryDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRegistryDlg::OnOk() 
{
	HKEY Key;
	BYTE VerDataBuffer[200],InstDataBuffer[200];
	DWORD VerVelikost = 5,InstVelikost = 128;

	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,"Software\\NuMega\\SoftICE\\",NULL, KEY_READ,&Key) == ERROR_SUCCESS)  // byl nalezen kl pidan SoftICem?
	{
		RegQueryValueEx(Key,"Current Version",NULL,NULL,VerDataBuffer,&VerVelikost);  // verze SoftICu
		RegQueryValueEx(Key,"InstallDir",NULL,NULL,InstDataBuffer,&InstVelikost);  // instalan adres SoftICu
		MessageBox((const char*)InstDataBuffer,(const char*)VerDataBuffer,MB_OK);
	}
	else
		MessageBox("SoftICE nenalezen",NULL,MB_OK);
}
