// BPMDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BPM.h"
#include "BPMDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBPMDlg dialog

CBPMDlg::CBPMDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBPMDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBPMDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBPMDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBPMDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBPMDlg, CDialog)
	//{{AFX_MSG_MAP(CBPMDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBPMDlg message handlers

BOOL CBPMDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBPMDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBPMDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBPMDlg::OnOk() 
{
	DWORD NaseAdresa;
	BYTE Probehlo = 0,DR7Break = 0;

	__asm
	{
		push offset BPMHandler  // adresa handleru
		push dword ptr fs:[0]  // uloen adresy pedchozho handleru
		mov fs:[0],esp  // instalace
			
		mov NaseAdresa,offset Adresa;  // naten adresy, odkud se budou
		                               // zadvat breakpointy
		INT 3  // 1. mysln vyvolan chyba znmou instrukc INT 3
			   // tato instrukce byla zvolena kvli nsledn trochu
			   // jednodu konstrukci handleru(jak jste si jist vimli)
			   // v dnm ppad ji nepouvejte v ochran	
		nop    
			
		nop  // ---I  1. breakpoint
		nop  //    I
			 //    I
		nop  //    I  2. breakpoint
		nop  // -----I
			 //      I--msta pro zadvn breakpoint 
		nop  // -----I  3. breakpoint
		nop  //    I
		     //    I
Adresa:      //    I
		nop  // ---I  4. breakpoint
		nop  //
			
		inc DR7Break // zvten hodnoty promnn DR7Break - v handleru tak
			         // dojde k vynulovn registru Dr7
			
		INT 3  // 2. zvren chyba pro vynulovn registru Dr7
		nop
			
		pop dword ptr fs:[0]  // obnoven pvodnho handleru
		add esp,4  // korekce zsobnku
		jmp Skok
			
			/*******Zde zan handler*******/
BPMHandler:	
		mov edx,[esp+0Ch]  // CONTEXT
		mov ecx,[esp+4]  // EXCEPTION_RECORD
			
		push ebp  // uloen hodnoty EBP
		mov ebp,[edx+0B4h]  // natenm pvodn hodnoty EBP jet ped
			                // vstupem do handleru umonme uvn
			                // promnnch
		mov ebx,NaseAdresa
			
		mov [edx+4],ebx  // Dr0
		sub ebx,2
		mov [edx+8],ebx  // Dr1
		sub ebx,2
		mov [edx+0Ch],ebx  // Dr2
		sub ebx,2
		mov [edx+10h],ebx  // Dr3 obsahuje breakpoint na prvn dvojici NOP
			
		and [edx+14h],0  // vynulovn registru Dr6
		mov [edx+18h],155h  // nastaven hodnoty dcho registru Dr7
			
		cmp DR7Break,0  // jedn se o posledn chybu vyvolanou instrukc INT 3?
		je MYjump 	
		and [edx+18h],0  // pokud ano, vynuluj pkazov registr Dr7
			
MYjump:
		mov eax,80000004h  // EAX = slo chyby STATUS_SINGLE_STEP, kterou 
                           // vyvol nastaven breakpoint
		mov ecx,[ecx]  // ECX = slo chyby, kter prv vznikla
		sub eax,ecx  // porovnn hodnot EAX a ECX
		je BreakPoint  // pokud se sla chyb shoduj, zvme poet
			           // spn zpracovanch breakpoint
		dec eax  // jedn se o chybu STATUS_BREAKPOINT(80000003h)
                 // vyvolanou instrukc INT 3?
		je Ok  // pokud ne, dolo k jin chyb v programu, kterou tento
               // handler nebude zpracovvat
			
		sub eax,eax
		inc eax  // ExceptionContinueSearch
		jmp Konec
			
BreakPoint:
		inc Probehlo  // zvten potu spn zpracovanch breakpoint
			
Ok:
		add dword ptr [edx+0B8h],1  // opraven chyby peskoenm chybn instrukce
		sub eax,eax  // ExceptionContinueExecution
			
Konec:
		pop ebp  // obnoven EBP
		ret

Skok:
	}

	if (Probehlo == 4)  // probhly vechny nastaven breakpointy spn?
		MessageBox("Hardwarov breakpoint nenalezen",NULL,MB_OK);
	else
		MessageBox("Hardwarov breakpoint nalezen",NULL,MB_OK);
}
