// VxDCallDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VxDCall.h"
#include "VxDCallDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVxDCallDlg dialog

CVxDCallDlg::CVxDCallDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVxDCallDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVxDCallDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVxDCallDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVxDCallDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVxDCallDlg, CDialog)
	//{{AFX_MSG_MAP(CVxDCallDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVxDCallDlg message handlers

BOOL CVxDCallDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVxDCallDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVxDCallDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVxDCallDlg::OnOk() 
{
	__asm
	{
		mov ax,ds
		test al,4  // o jak operan systm se jedn?
		je Not_Win9x  // skok = nejedn se o operan systm Windows 9x/Me
			
Win9x:
		push offset MyHandler  // adresa handleru     
		push dword ptr fs:[0]  // uloen adresy pedchozho handleru      
		mov dword ptr fs:[0],esp  // instalace
			
		pushfd 
		mov eax,esp

		xor ebx,ebx  // EBX = 0          
		mov ecx,[ebx]  // --> Ring0 (STATUS_ACCESS_VIOLATION)
			
		/*******Ring0*******/
		push edx  // GS
		push edx  // FS
		push edx  // ES
		push edx  // DS
		push edx  // SS
		push eax  // ESP
		push dword ptr [eax]  // EFLAGS
		push ecx  // CS
		push offset Ring3  // EIP = adresa pro nvrat do Ring3
			
		__emit 0xCD	 // VMMCall  VMM_GetDDBList                  	
		__emit 0x20  //
		__emit 0x3F  //
		__emit 1  //
		__emit 1  //
		__emit 0  //
		iretd  // --> Ring3
		       // pokud se dostaneme a sem, FrogsICE nen aktivn v pamti
			
Ring3:
		popfd  
		pop dword ptr fs:[0]  // obnoven pvodnho handleru
		add  esp,4  // korekce zsobnku   
		jmp Ok
			
		/*******MyHandler*******/
		// SEH handler pro pechod do Ring0
MyHandler:
		mov edx,[esp+0Ch]  // CONTEXT
		mov ecx,[esp+4]  // EXCEPTION_RECORD
		mov ecx,[ecx]  // ECX = slo chyby, kter prv vznikla
		cmp ecx,0C0000005h  // jedn se o chybu STATUS_ACCESS_VIOLATION(C0000005h)?
		jne Chyba  // skok = jedn se o jinou chybu, kterou tento handler
		           // nebude zpracovvat
		add dword ptr [edx+0B8h],2  // opraven chyby peskoenm chybn instrukce
		movzx ecx,word ptr [edx+0BCh]
		mov [edx+0ACh],ecx             
		mov dword ptr [edx+0BCh],28h   
		movzx ecx,word ptr [edx+0C8h]
		mov [edx+0A8h],ecx             
		mov dword ptr [edx+0C8h],30h   
    	or dword ptr [edx+0C0h],200h 
		sub eax,eax  // ExceptionContinueExecution
		ret  // --> Ring0
			
Chyba:
		sub eax,eax
		inc eax  // ExceptionContinueSearch
		ret
	}
Not_Win9x:
	MessageBox("Tato metoda funguje pouze ve Windows 9x/Me",NULL,MB_OK);
	return;
		
Ok:
	MessageBox("FrogsICE nenalezen",NULL,MB_OK);
}
