// RSADlg.h : header file
//

#if !defined(AFX_RSADLG_H__A2F4F9F9_9A8F_451F_9BBC_99A19E3DC596__INCLUDED_)
#define AFX_RSADLG_H__A2F4F9F9_9A8F_451F_9BBC_99A19E3DC596__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CRSADlg dialog

class CRSADlg : public CDialog
{
// Construction
public:
	CRSADlg(CWnd* pParent = NULL);	// standard constructor
	BOOL TestPrc(int cislo);
	__int64 GetNSD(__int64 a, __int64 b);
	__int64 GetPrime(__int64 start);
	__int64 GetD(__int64 start, __int64 end, __int64 p, __int64 q, __int64 e);

// Dialog Data
	//{{AFX_DATA(CRSADlg)
	enum { IDD = IDD_RSA_DIALOG };
	int		m_dend;
	int		m_dstart;
	int		m_e;
	int		m_estart;
	int		m_p;
	int		m_hereprv;
	int		m_odkudprv;
	int		m_q;
	double	m_d;
	int		m_x;
	double	m_dd;
	int		m_ze;
	double	m_pkq;
	double	m_pkq2;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRSADlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CRSADlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnPrvsearch();
	afx_msg void OnInsp();
	afx_msg void OnInsq();
	afx_msg void OnSearche();
	afx_msg void OnSearchd();
	afx_msg void OnChangeP();
	afx_msg void OnChangeQ();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RSADLG_H__A2F4F9F9_9A8F_451F_9BBC_99A19E3DC596__INCLUDED_)
